'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var G6 = require('@antv/g6');
var G6__default = _interopDefault(G6);

// mock 数据  example 数据
var data = {
  deptId: 'root',
  disable: false,
  deptName: '静静测试',
  expand: true,
  managerEmp: [{
    userId: 'id1',
    name: '汤三狗1111111111111111',
    avatar: 'https://img.renlijia.com/202208/RLJMaBnU53SEJwAM2x3k8M795M-720-720.jpg',
    jobLevel: 'P6',
    jobTitle: 'CEO'
  }, {
    userId: 'id2',
    name: '姚二猫2222222222',
    avatar: 'https://img.renlijia.com/202208/RLJX4R7SBOK9EbJQk21j9Q566v-300-300.jpeg',
    jobLevel: 'P6',
    jobTitle: 'CEO'
  }, {
    userId: 'id3',
    name: '张三炮'
  }, {
    userId: 'id4',
    name: '李四'
  }],
  hireCount: 1,
  hireCountMore: 2,
  empCount: 2,
  empCountMore: 3,
  children: [{
    deptId: 'c1',
    label: 'c1',
    position: '1',
    children: [{
      deptId: 'c1-1',
      label: 'c1-1'
    }, {
      deptId: 'c1-2',
      label: 'c1-2',
      children: [{
        deptId: 'c1-2-1',
        label: 'c1-2-1'
      }, {
        deptId: 'c1-2-2',
        label: 'c1-2-2'
      }]
    }]
  }, {
    deptId: 'c2',
    label: 'c2'
  }, {
    deptId: 'c3',
    label: 'c3',
    children: [{
      deptId: 'c3-1',
      label: 'c3-1'
    }, {
      deptId: 'c3-2',
      label: 'c3-2',
      children: [{
        deptId: 'c3-2-1',
        label: 'c3-2-1'
      }, {
        deptId: 'c3-2-2',
        label: 'c3-2-2'
      }, {
        deptId: 'c3-2-3',
        label: 'c3-2-3'
      }]
    }, {
      deptId: 'c3-3',
      label: 'c3-3'
    }]
  }]
}; // new Array(200).fill(1).forEach((v, i) => {
//   data.children.push({ deptId: 'newNode1' + v + i, label: '1' });
// });
// function setNode(index: number) {
//   const tmp = new Array(200).fill(index).map((v, i) => ({
//     deptId: Math.random() + '' + v + i,
//     label: '1',
//   }));
//   data.children[index].children = tmp;
// }
// new Array(20).fill(1).forEach((...[, i]) => {
//   setNode(i);
// });
// console.log(data);

// 展示信息 默认配置
var defaultShow = {
  managerEmp: true,
  jobTitle: true,
  jobLevel: true,
  hireCount: true,
  empCount: true,
  hireCountMore: true,
  empCountMore: true
}; // 关键数据 key 默认值

var defaultMap = {
  deptId: 'id',
  managerEmp: {
    key: 'managerEmp',
    value: {
      id: 'userId',
      name: 'name',
      avatar: 'avatar',
      jobTitle: 'jobTitle',
      jobLevel: 'jobLevel'
    }
  },
  disable: 'disable',
  deptName: 'name',
  hireCount: 'hireCount',
  empCount: 'empCount',
  hireCountMore: 'hireCountMore',
  empCountMore: 'empCountMore'
}; // 卡片大小间距 默认值

var config = {
  defaultDepth: 1,
  vPadding: 8,
  edge: {
    arrowSize: [8, 8],
    arrowBackground: '#D0D8E4',
    edgeBackground: '#D0D8E4',
    width: 1
  },
  card: {
    width: 130,
    radius: 4,
    vGap: [26, 26],
    hGap: 14
  },
  collapseIcon: {
    radius: 6,
    background: '#fff',
    color: '#0089FF'
  },
  assistBox: {
    isShow: true,
    width: 20,
    background: 'transparent',
    color: '#262626',
    fontSize: 12,
    iconArr: ["\uE64C", "\uE6B9", "\uE67A"],
    iconDis: 10
  },
  header: {
    height: 40,
    background: '#29A2FF',
    main: {
      fontSize: 12,
      fontWeight: 'bold',
      color: '#fff'
    },
    sub: {
      fontSize: 8,
      fontWeight: 'normal',
      color: 'rgba(255, 255, 255, 0.8)'
    }
  },
  content: {
    maxItem: 3,
    scrollBar: 6,
    scrollBarBk: ['#c1c1c1', '#fafafa'],
    height: 54,
    background: '#fff',
    distance: [4, 10],
    divider: {
      height: 14,
      width: 1,
      background: '#F5F5F5'
    },
    avatar: {
      width: 30,
      height: 30,
      radius: 6,
      background: '#29A2FF',
      color: '#fff',
      fontSize: 10
    },
    main: {
      fontSize: 10,
      fontWeight: 'bold',
      color: '#262626'
    },
    sub: {
      fontSize: 8,
      fontWeight: 'normal',
      color: '#8C8C8C'
    },
    extra: {
      fontSize: 8,
      fontWeight: 'normal',
      color: '#8c8c8c'
    }
  },
  footer: {
    height: 24,
    background: '#fff',
    text: {
      fontSize: 8,
      fontWeight: 'normal',
      color: '#8C8C8C'
    },
    divider: {
      vPadding: 10,
      height: 1,
      background: '#F5F5F5'
    }
  }
}; // node 节点 默认样式

var defaultNodeStyle = {
  fill: '#fff',
  // stroke: '#75ca86',
  shadowColor: '#e8e8e8',
  shadowOffsetX: 0,
  shadowOffsetY: 2,
  shadowBlur: 6,
  radius: 4
}; // 折叠图标-加号

var COLLAPSE_ICON = function COLLAPSE_ICON(x, y, r) {
  return [['M', x - r, y - r], ['a', r, r, 0, 1, 0, r * 2, 0], ['a', r, r, 0, 1, 0, -r * 2, 0], ['M', x + 2 - r, y - r], ['L', x + r - 2, y - r]];
}; // 折叠图标-减号

var EXPAND_ICON = function EXPAND_ICON(x, y, r) {
  return [['M', x - r, y - r], ['a', r, r, 0, 1, 0, r * 2, 0], ['a', r, r, 0, 1, 0, -r * 2, 0], ['M', x + 2 - r, y - r], ['L', x + r - 2, y - r], ['M', x, y - 2 * r + 2], ['L', x, y - 2]];
};

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var ORG_ROOT = /*#__PURE__*/new Map();
var getOrgRoot = function getOrgRoot(key) {
  return ORG_ROOT.get(key);
};
var setOrgRootFirst = function setOrgRootFirst(key, param) {
  ORG_ROOT.set(key, param);
};
var setOrgRoot = function setOrgRoot(key, param) {
  var cur = getOrgRoot(key);
  if (!cur) return;
  ORG_ROOT.set(key, _extends({}, cur, param || {}));
};

var getDefaultShow = function getDefaultShow(param) {
  return _extends({}, defaultShow, param || {});
};
var getCardMap = function getCardMap(param) {
  if (!param) return defaultMap;
  return _extends({}, defaultMap, param || {}, {
    managerEmp: _extends({}, defaultMap.managerEmp, (param || {}).managerEmp || {}, {
      value: _extends({}, defaultMap.managerEmp.value, ((param || {}).managerEmp || {}).value || {})
    })
  });
}; // 空间距离参数和组件props入参拼接

var getConfig = function getConfig(param) {
  if (!param) return config;
  return _extends({}, config, param || {}, {
    edge: _extends({}, config.edge, param.edge || {}),
    card: _extends({}, config.card, param.card || {}),
    collapseIcon: _extends({}, config.collapseIcon, param.collapseIcon || {}),
    assistBox: _extends({}, config.assistBox, param.assistBox || {}),
    header: _extends({}, config.header, param.header || {}, {
      main: _extends({}, config.header.main, (param.header || {}).main || {}),
      sub: _extends({}, config.header.sub, (param.header || {}).sub || {})
    }),
    content: _extends({}, config.content, param.content || {}, {
      avatar: _extends({}, config.content.avatar, (param.content || {}).avatar || {}),
      divider: _extends({}, config.content.divider, (param.content || {}).divider || {}),
      main: _extends({}, config.content.main, (param.content || {}).main || {}),
      sub: _extends({}, config.content.sub, (param.content || {}).sub || {}),
      extra: _extends({}, config.content.extra, (param.content || {}).extra || {})
    }),
    footer: _extends({}, config.footer, param.footer || {}, {
      text: _extends({}, config.footer.text, (param.footer || {}).text || {}),
      divider: _extends({}, config.footer.divider, (param.footer || {}).divider || {})
    })
  });
}; // 获取节点布局配置 layout

var getDefaultLayout = function getDefaultLayout(compKey) {
  return {
    type: 'compactBox',
    direction: 'TB',
    getId: function getId(d) {
      return d.id;
    },
    getWidth: function getWidth(d) {
      var cardMap = getOrgRoot(compKey).cardMap;
      var managerEmp = d.meta[cardMap.managerEmp.key];
      return getCardWidthHeight(managerEmp, compKey)[0];
    },
    getHeight: function getHeight(d) {
      var cardMap = getOrgRoot(compKey).cardMap;
      var managerEmp = d.meta[cardMap.managerEmp.key];
      return getCardWidthHeight(managerEmp, compKey)[1];
    },
    getVGap: function getVGap() {
      var config = getOrgRoot(compKey).config;
      var _config$card$vGap = config.card.vGap,
          top = _config$card$vGap[0],
          bottom = _config$card$vGap[1];
      return (top + bottom) / 2;
    },
    getHGap: function getHGap() {
      var config = getOrgRoot(compKey).config;
      return config.card.hGap;
    }
  };
}; // 获取卡片(node节点)宽度和高度

var getCardWidthHeight = function getCardWidthHeight(emp, compKey) {
  var base = getOrgRoot(compKey);
  var showHide = base.showHide,
      config = base.config;
  var card = config.card,
      content = config.content,
      footer = config.footer,
      header = config.header;
  var len = (emp || []).length || 1;
  var tmpHeight = header.height;

  if (showHide.managerEmp) {
    tmpHeight += content.height;
  } else {
    len = 1;
  }

  if (showHide.hireCountMore || showHide.empCountMore) {
    tmpHeight += footer.height;
  }

  if (len > config.content.maxItem) {
    len = config.content.maxItem;
  }

  return [card.width * len, tmpHeight];
}; // 获取可用模块

var getModule = function getModule(a) {
  return {
    header: true,
    content: a.managerEmp,
    footer: a.hireCountMore || a.empCountMore,
    isOnlyHeader: !a.managerEmp && !a.hireCountMore && !a.empCountMore,
    jobLevel: a.jobLevel,
    jobTitle: a.jobTitle,
    isHirOrEmp: a.empCount || a.hireCount,
    empCount: a.empCount,
    hireCount: a.hireCount,
    isHirOrEmpMore: a.empCountMore || a.hireCountMore,
    empCountMore: a.empCountMore,
    hireCountMore: a.hireCountMore
  };
}; // 获取字体高度

var _getTextHeight = function getTextHeight(size) {
  var a = G6__default.Util.getTextSize('字体高度模拟文案', 10);
  var radio = a[1] / 10;

  _getTextHeight = function getTextHeight(size) {
    return radio * size;
  };

  return radio * size;
};

var CONTENT = {
  ID: {
    GROUP: 'contentGroup'
  },
  NAME: {
    GROUP: 'contentGroup',
    BACK_RECT: 'contentContainer',
    EMPTY_TEXT: 'contentEmptyText',
    SCROLLBAR: {
      INNER: 'extraScrollBar',
      OUTER: 'extraScrollBarBK'
    },
    PREFIX: {
      AVATAR: {
        BACK: 'contentAvatar_',
        TEXT: 'contentAvatarText_'
      },
      DIVISION: 'contentDivision_',
      MAIN_TEXT: 'contentTextMain_',
      SUB_TEXT: 'contentTextSub_',
      EXTRA_TEXT: 'contentTextExtra_'
    }
  }
};
var NODE_WHOLE = {
  ID: {
    GROUP: 'nodeCollapseGroup'
  },
  NAME: {
    GROUP: 'nodeCollapseGroup',
    COLLAPSE: 'nodeCollapseIcon',
    LOADING: 'nodeCollapseLoading',
    LOADINGBk: 'nodeCollapseLoadingBk'
  }
};
var ASSIST_BOX = {
  ID: {
    GROUP: 'assistBoxGroup'
  },
  NAME: {
    GROUP: 'assistBoxGroup'
  }
};

var initScroll = function initScroll(compKey) {
  var eventName = 'row-scroll';
  var startClientX;
  G6.registerBehavior(eventName, {
    getEvents: function getEvents() {
      return {
        wheel: 'handleScroll',
        'node:mousemove': 'handleMove',
        'node:mousedown': 'handleDown',
        'node:mouseup': 'handleUp',
        'node:mouseleave': 'handleLeave'
      };
    },
    handleScroll: function handleScroll(e) {
      e.preventDefault();
      var param = getOrgRoot(compKey);
      var cardMap = param.cardMap,
          config = param.config,
          showHide = param.showHide;
      if (!getModule(showHide).content) return;
      var nodes = getNodes(this, e);
      if (!nodes) return;
      var curOffset = -e.deltaX * 0.5;
      handleMoveWithX(nodes, curOffset, config, cardMap);
    },
    handleDown: function handleDown(e) {
      startClientX = e.clientX;
    },
    handleMove: function handleMove(e) {
      if (startClientX === undefined) return;
      var param = getOrgRoot(compKey);
      var cardMap = param.cardMap,
          config = param.config,
          showHide = param.showHide;
      if (!getModule(showHide).content) return;
      var nodes = getNodes(this, e);
      if (!nodes) return;
      var distance = e.clientX - startClientX;
      handleMoveWithX(nodes, -distance, config, cardMap);
      startClientX = e.clientX;
    },
    handleUp: function handleUp() {
      startClientX = undefined;
    },
    handleLeave: function handleLeave() {
      startClientX = undefined;
    }
  });
  return eventName;
}; // 是否在容器内

var isInBBox = function isInBBox(point, bBox) {
  var x = point.x,
      y = point.y;
  var minX = bBox.minX,
      minY = bBox.minY,
      maxX = bBox.maxX,
      maxY = bBox.maxY;
  return x < maxX && x > minX && y > minY && y < maxY;
}; // 获取当前鼠标所在的节点

var getNodes = function getNodes(a, b) {
  var graph = a.graph;
  var nodes = graph.getNodes().filter(function (n) {
    var bBox = n.getBBox();
    return isInBBox(graph.getPointByClient(b.clientX, b.clientY), bBox);
  });
  return nodes;
};

var getContentGroup = function getContentGroup(node) {
  var group = node.getContainer().findById('contentGroup');

  var _group$findAll = group.findAll(function (item) {
    return item.get('name').includes(CONTENT.NAME.PREFIX.AVATAR.BACK);
  }),
      firstAvatar = _group$findAll[0];

  var lastScrollBar = group.find(function (item) {
    return item.get('name') === CONTENT.NAME.SCROLLBAR.INNER;
  });
  var backRect = group.find(function (item) {
    return item.get('name') === CONTENT.NAME.BACK_RECT;
  });
  return {
    group: group,
    backRect: backRect,
    firstAvatar: firstAvatar,
    lastScrollBar: lastScrollBar
  };
};

var handleMoveWithX = function handleMoveWithX(nodes, curOffset, config, cardMap) {
  var content = config.content,
      card = config.card;
  var managerEmpAttr = cardMap.managerEmp.key;
  nodes.forEach(function (node) {
    var model = node.getModel();
    var managerEmp = model.meta[managerEmpAttr] || [];
    if (managerEmp.length <= content.maxItem) return;
    var maxOffset = (managerEmp.length - content.maxItem) * card.width;

    var _getContentGroup = getContentGroup(node),
        group = _getContentGroup.group,
        firstAvatar = _getContentGroup.firstAvatar,
        lastScrollBar = _getContentGroup.lastScrollBar,
        backRect = _getContentGroup.backRect;

    if (firstAvatar.attr('x') + curOffset > config.vPadding) {
      curOffset = config.vPadding - firstAvatar.attr('x');
    }

    if (firstAvatar.attr('x') + curOffset < config.vPadding - maxOffset) {
      curOffset = config.vPadding - maxOffset - firstAvatar.attr('x');
    }

    if (lastScrollBar) {
      var remnant = backRect.attr('width') - lastScrollBar.attr('width');
      var radio = Math.abs(firstAvatar.attr('x') + curOffset - config.vPadding) / maxOffset;
      lastScrollBar.attr({
        x: remnant * radio
      });
    }

    var filterName = [CONTENT.NAME.SCROLLBAR.INNER, CONTENT.NAME.SCROLLBAR.OUTER, CONTENT.NAME.BACK_RECT]; // 每次给滚动条加一点距离

    group.findAll(function (item) {
      var itemName = item.get('name') || '';
      if (!itemName) return false;
      if (filterName.includes(itemName)) return false;

      if (itemName.includes(CONTENT.NAME.PREFIX.DIVISION)) {
        var path = item.attr('path');
        var x = path[0][1];
        path[0][1] = x + curOffset;
        path[1][1] = x + curOffset;
        item.attr({
          path: path
        });
        return false;
      }

      item.attr({
        x: item.attr('x') + curOffset
      });
      var itemClip = item.getClip();

      if (itemClip) {
        itemClip.attr({
          x: itemClip.attr('x') + curOffset
        });
      }

      return false;
    });
  });
};

var fitString = function fitString(str, maxWidth, fontSize) {
  var ellipsis = '...';
  var ellipsisLength = G6__default.Util.getTextSize(ellipsis, fontSize)[0];
  var currentWidth = 0;
  var res = str;
  var pattern = new RegExp("[\u4E00-\u9FA5]+"); // distinguish the Chinese word and letters

  str.split('').forEach(function (letter, i) {
    if (currentWidth > maxWidth - ellipsisLength) return;

    if (pattern.test(letter)) {
      // Chinese word
      currentWidth += fontSize;
    } else {
      // get the width of single letter according to the fontSize
      currentWidth += G6__default.Util.getLetterWidth(letter, fontSize);
    }

    if (currentWidth > maxWidth - ellipsisLength) {
      res = "" + str.substr(0, i) + ellipsis;
    }
  });
  return res;
}; // 获取树对象的深度

var getTreeDepth = function getTreeDepth(data) {
  var tmp = [];

  var fn = function fn(data, index) {
    tmp.push(index);

    if (data && data.children) {
      for (var i = 0; i < data.children.length; i++) {
        fn(data.children[i], index + 1);
      }
    }
  };

  fn(data, 0);
  return Math.max.apply(Math, tmp);
}; // 设置节点 id

var traverse = function traverse(data, fn, index) {
  if (!fn(data, index)) return false;

  if (data && data.children) {
    for (var i = 0; i < data.children.length; i++) {
      if (!traverse(data.children[i], fn, index + 1)) return false;
    }
  }

  return true;
};

var traverseTree = function traverseTree(data, compKey, curDepth) {
  var _getOrgRoot = getOrgRoot(compKey),
      cardMap = _getOrgRoot.cardMap,
      config = _getOrgRoot.config;

  var dataClone = JSON.parse(JSON.stringify(data));
  traverse(dataClone, function (d, depth) {
    var id = d[cardMap.deptId];
    var meta = {};
    Object.keys(d).forEach(function (v) {
      if (['children'].includes(v)) return;
      meta[v] = d[v];
      delete d[v];
    });
    d.id = id;
    d.meta = meta;
    d.collapsed = depth >= config.defaultDepth;
    return true;
  }, curDepth);
  return dataClone;
};

var setHeader = function setHeader(param) {
  var group = param.group,
      config = param.config,
      w = param.w,
      cardMap = param.cardMap,
      cfg = param.cfg,
      showHide = param.showHide;
  var header = config.header,
      card = config.card,
      vPadding = config.vPadding;
  var module = getModule(showHide);
  group.addShape('rect', {
    attrs: {
      x: 0,
      y: 0,
      width: w,
      height: header.height,
      fill: header.background,
      radius: module.isOnlyHeader ? card.radius : [card.radius, card.radius, 0, 0]
    }
  });
  var mainH = _getTextHeight(header.main.fontSize);
  var subH = _getTextHeight(header.sub.fontSize);
  var distanceMainSub = 4;
  var mainY = (header.height - distanceMainSub - mainH - subH) / 2;
  group.addShape('text', {
    attrs: {
      x: vPadding,
      y: !module.isHirOrEmp ? header.height / 2 : mainY,
      textBaseline: !module.isHirOrEmp ? 'middle' : 'top',
      text: fitString(cfg.meta[cardMap.deptName] || '-', w - vPadding * 2, header.main.fontSize),
      fill: header.main.color,
      fontSize: header.main.fontSize,
      fontWeight: header.main.fontWeight
    }
  });

  if (module.isHirOrEmp) {
    var txt = [];

    if (showHide.empCount) {
      txt.push('在编 ' + (cfg.meta[cardMap.empCount] || 0));
    }

    if (showHide.hireCount) {
      txt.push('编制 ' + (cfg.meta[cardMap.hireCount] || 0));
    }

    group.addShape('text', {
      attrs: {
        x: vPadding,
        y: mainY + distanceMainSub + mainH,
        textBaseline: 'top',
        text: fitString('本级' + txt.join(' / '), w - vPadding * 2, header.sub.fontSize),
        fill: header.sub.color,
        fontSize: header.sub.fontSize,
        fontWeight: header.sub.fontWeight
      }
    });
  }
};
var setContent = function setContent(param) {
  var module = getModule(param.showHide);
  if (!module.content) return;
  var w = param.w,
      config = param.config,
      cardMap = param.cardMap,
      cfg = param.cfg,
      showHide = param.showHide;
  var header = config.header,
      content = config.content,
      card = config.card,
      vPadding = config.vPadding;
  var _cardMap$managerEmp = cardMap.managerEmp,
      attr = _cardMap$managerEmp.key,
      attrEnum = _cardMap$managerEmp.value;
  var group = param.group.addGroup({
    id: CONTENT.ID.GROUP,
    name: CONTENT.NAME.GROUP
  });
  group.setClip({
    type: 'rect',
    attrs: {
      x: 0,
      y: header.height,
      width: w,
      height: content.height,
      radius: module.footer ? 0 : [0, 0, card.radius, card.radius]
    }
  });
  group.addShape('rect', {
    attrs: {
      x: 0,
      y: header.height,
      width: w,
      height: content.height,
      fill: content.background,
      radius: module.footer ? 0 : [0, 0, card.radius, card.radius]
    },
    name: CONTENT.NAME.BACK_RECT
  });

  if (!(cfg.meta[attr] || []).length) {
    var textY = header.height + content.height / 2;
    group.addShape('text', {
      attrs: {
        x: card.width / 2,
        y: textY,
        textBaseline: 'middle',
        text: '暂无负责人',
        fill: '#262626',
        fontSize: 10,
        textAlign: 'center'
      },
      name: CONTENT.NAME.EMPTY_TEXT
    });
    return;
  }

  cfg.meta[attr].forEach(function (item, index) {
    var imageX = vPadding + index * card.width;
    var imageY = header.height + (content.height - content.avatar.height) / 2;
    var nameSuffix = item[attrEnum.id] + '_' + index;

    if (item.avatar) {
      group.addShape('image', {
        attrs: {
          x: imageX,
          y: imageY,
          width: content.avatar.width,
          height: content.avatar.height,
          img: item.avatar
        },
        name: CONTENT.NAME.PREFIX.AVATAR.BACK + nameSuffix
      }).setClip({
        type: 'rect',
        attrs: {
          x: imageX,
          y: imageY,
          show: true,
          width: content.avatar.width,
          height: content.avatar.height,
          radius: content.avatar.radius
        }
      });
    } else {
      group.addShape('rect', {
        attrs: {
          x: imageX,
          y: imageY,
          width: content.avatar.width,
          height: content.avatar.height,
          radius: content.avatar.radius,
          fill: content.avatar.background
        },
        name: CONTENT.NAME.PREFIX.AVATAR.BACK + nameSuffix
      });
      group.addShape('text', {
        attrs: {
          x: imageX + content.avatar.width / 2,
          y: imageY + content.avatar.height / 2,
          textBaseline: 'middle',
          text: item[attrEnum.name].slice(-2),
          fill: content.avatar.color,
          fontSize: content.avatar.fontSize,
          textAlign: 'center'
        },
        name: CONTENT.NAME.PREFIX.AVATAR.TEXT + nameSuffix
      });
    }

    var divisionX = card.width * index;
    var divisionY = header.height;
    divisionY += (content.height - content.divider.height) / 2;

    if (index !== 0) {
      group.addShape('path', {
        attrs: {
          path: [['M', divisionX, divisionY], ['L', divisionX, divisionY + content.divider.height]],
          stroke: content.divider.background,
          lineWidth: content.divider.width,
          lineAppendWidth: content.divider.width + 2
        },
        name: CONTENT.NAME.PREFIX.DIVISION + nameSuffix
      });
    }

    var textW = card.width - content.avatar.width - content.distance[0] - content.distance[1] - vPadding;
    var textX = imageX + content.avatar.width + content.distance[0];
    var mainH = _getTextHeight(content.main.fontSize);
    var subH = _getTextHeight(content.sub.fontSize);
    var extraH = _getTextHeight(content.extra.fontSize);
    var allH = mainH;

    if (module.jobTitle) {
      allH += 2; // 间距

      allH += subH;
    }

    if (module.jobLevel) {
      allH += 2; // 间距

      allH += extraH;
    }

    var upDown = (content.avatar.height - allH) / 2;
    group.addShape('text', {
      attrs: {
        x: textX,
        y: imageY + upDown,
        textBaseline: 'top',
        text: fitString(item[attrEnum.name] || '-', textW, content.main.fontSize),
        fill: content.main.color,
        fontSize: content.main.fontSize,
        fontWeight: content.main.fontWeight
      },
      name: CONTENT.NAME.PREFIX.MAIN_TEXT + nameSuffix
    });

    if (showHide.jobTitle) {
      group.addShape('text', {
        attrs: {
          x: textX,
          y: imageY + upDown + 2 + mainH,
          textBaseline: 'top',
          text: fitString(item[attrEnum.jobTitle] || '-', textW, content.sub.fontSize),
          fill: content.sub.color,
          fontSize: content.sub.fontSize,
          fontWeight: content.sub.fontWeight
        },
        name: CONTENT.NAME.PREFIX.SUB_TEXT + nameSuffix
      });
    }

    if (showHide.jobLevel) {
      group.addShape('text', {
        attrs: {
          x: textX,
          y: imageY + upDown + 2 + mainH + (showHide.jobTitle ? 2 + subH : 0),
          textBaseline: 'top',
          text: fitString(item[attrEnum.jobLevel] || '-', textW, content.extra.fontSize),
          fill: content.extra.color,
          fontSize: content.extra.fontSize,
          fontWeight: content.extra.fontWeight
        },
        name: CONTENT.NAME.PREFIX.EXTRA_TEXT + nameSuffix
      });
    }
  }); // 滚动条

  if (cfg.meta[attr].length > content.maxItem) {
    group.addShape('rect', {
      attrs: {
        x: 0,
        y: header.height + content.height - content.scrollBar - 2,
        width: w,
        height: content.scrollBar + 2,
        fill: content.scrollBarBk[1]
      },
      name: CONTENT.NAME.SCROLLBAR.OUTER
    });
    group.addShape('rect', {
      attrs: {
        x: 0,
        y: header.height + content.height - content.scrollBar - 1,
        width: w * (content.maxItem / cfg.meta[attr].length),
        height: content.scrollBar,
        fill: content.scrollBarBk[0],
        radius: content.scrollBar / 2
      },
      name: CONTENT.NAME.SCROLLBAR.INNER
    });
  }
};
var setFooter = function setFooter(param) {
  var module = getModule(param.showHide);
  if (!module.footer) return;
  var config = param.config,
      group = param.group,
      w = param.w,
      cardMap = param.cardMap,
      showHide = param.showHide,
      h = param.h,
      cfg = param.cfg;
  var footer = config.footer,
      card = config.card,
      vPadding = config.vPadding;
  group.addShape('rect', {
    attrs: {
      x: 0,
      y: h - footer.height,
      width: w,
      height: footer.height,
      fill: footer.background,
      radius: [0, 0, card.radius, card.radius]
    }
  });

  if (module.content) {
    group.addShape('path', {
      attrs: {
        path: [['M', footer.divider.vPadding, h - footer.height], ['L', w - footer.divider.vPadding, h - footer.height]],
        stroke: footer.divider.background,
        lineWidth: footer.divider.height || 1,
        lineAppendWidth: footer.divider.height + 2
      }
    });
  }

  var txt = [];

  if (showHide.empCountMore) {
    txt.push('在编 ' + (cfg.meta[cardMap.empCountMore] || 0));
  }

  if (showHide.hireCountMore) {
    txt.push('编制 ' + (cfg.meta[cardMap.hireCountMore] || 0));
  }

  group.addShape('text', {
    attrs: {
      x: vPadding,
      y: h - footer.height / 2,
      textBaseline: 'middle',
      text: fitString('含下级' + txt.join(' / '), w - vPadding * 2, footer.text.fontSize),
      fill: footer.text.color,
      fontSize: footer.text.fontSize,
      fontWeight: footer.text.fontWeight
    }
  });
};
var setCollapseIcon = function setCollapseIcon(param) {
  var cfg = param.cfg,
      h = param.h,
      w = param.w,
      config = param.config,
      group = param.group;
  if (!cfg.meta.expand) return;
  var collapseGroup = group.addGroup({
    id: NODE_WHOLE.ID.GROUP,
    name: NODE_WHOLE.NAME.GROUP
  });
  collapseGroup.addShape('path', {
    attrs: {
      path: [['M', w / 2, h], ['L', w / 2, h + config.card.vGap[0] / 2]],
      stroke: config.edge.edgeBackground,
      lineWidth: config.edge.width,
      lineAppendWidth: config.edge.width + 2
    }
  }); // 1 => 加号    2 => 减号

  var getIconStatus = function getIconStatus() {
    if (cfg.collapsed === true) return 1;
    if (cfg.collapsed === false) return 2;

    if (cfg.collapsed === undefined && cfg.depth < config.defaultDepth) {
      return 2;
    }

    return 1;
  };

  var radius = config.collapseIcon.radius;

  if (cfg.depth >= config.defaultDepth) {
    collapseGroup.addShape('rect', {
      attrs: {
        x: w / 2 - radius,
        y: h + config.card.vGap[0] / 2 + radius / 2 + 2 - radius * 2,
        width: radius * 2,
        height: radius * 2,
        cursor: 'pointer',
        radius: radius,
        fill: config.collapseIcon.background
      },
      name: NODE_WHOLE.NAME.LOADINGBk
    }).hide();
    collapseGroup.addShape('text', {
      attrs: {
        x: w / 2,
        y: h + config.card.vGap[0] / 2 + radius / 2 + 2 - radius,
        fontFamily: 'iconfont',
        text: "\uE701",
        fontSize: radius * 2,
        fill: config.collapseIcon.color,
        textBaseline: 'middle',
        cursor: 'pointer',
        textAlign: 'center'
      },
      name: NODE_WHOLE.NAME.LOADING
    }).hide();
  }

  collapseGroup.addShape('marker', {
    attrs: {
      x: w / 2,
      y: h + config.card.vGap[0] / 2 + config.collapseIcon.radius / 2 + 2,
      r: config.collapseIcon.radius,
      stroke: config.collapseIcon.color,
      fill: config.collapseIcon.background,
      cursor: 'pointer',
      symbol: getIconStatus() === 1 ? EXPAND_ICON : COLLAPSE_ICON
    },
    name: NODE_WHOLE.NAME.COLLAPSE
  });
};
var setAssistIcon = function setAssistIcon(param) {
  var group = param.group,
      w = param.w,
      h = param.h,
      config = param.config;
  if (!config.assistBox.isShow) return;
  var iconArr = config.assistBox.iconArr;
  var len = iconArr.length;
  var iconSize = config.assistBox.fontSize;
  var iconLeft = (config.assistBox.width - iconSize) / 2 + w;
  var iconDis = config.assistBox.iconDis;
  var iconTop = (h - len * iconSize - (len - 1) * iconDis) / 2;
  var assistGroup = group.addGroup({
    id: ASSIST_BOX.ID.GROUP,
    name: ASSIST_BOX.NAME.GROUP
  });
  assistGroup.hide();
  assistGroup.addShape('rect', {
    attrs: {
      width: config.assistBox.width,
      height: h,
      fill: config.assistBox.background,
      x: w,
      y: 0
    }
  });
  iconArr.forEach(function (v, i) {
    assistGroup.addShape('text', {
      attrs: {
        x: iconLeft,
        y: iconTop + (iconDis + iconSize) * i,
        fontFamily: 'iconfont',
        text: v,
        fontSize: iconSize,
        fill: config.assistBox.color,
        textBaseline: 'top',
        cursor: 'pointer'
      },
      name: ASSIST_BOX.NAME.GROUP + '_icon_' + i
    });
  });
};

var registerNode = function registerNode(compKey) {
  var nodeName = 'icon-node';
  G6__default.registerNode(nodeName, {
    options: {},
    draw: function draw(a, b) {
      var paramBase = getOrgRoot(compKey);
      var cardMap = paramBase.cardMap,
          config = paramBase.config,
          showHide = paramBase.showHide;
      var cfg = a;
      var group = b;

      var _getCardWidthHeight = getCardWidthHeight(cfg.meta[cardMap.managerEmp.key], compKey),
          w = _getCardWidthHeight[0],
          h = _getCardWidthHeight[1];

      var param = {
        group: group,
        config: config,
        w: w,
        h: h,
        cardMap: cardMap,
        cfg: cfg,
        showHide: showHide
      };
      var keyShape = group.addShape('rect', {
        attrs: _extends({}, defaultNodeStyle, {
          width: w,
          height: h,
          x: 0,
          y: 0
        })
      });
      setHeader(param);
      setContent(param);
      setFooter(param);
      setCollapseIcon(param);
      setAssistIcon(param);
      return keyShape;
    },
    update: undefined
  }, 'rect');
  return nodeName;
};
var registerEdge = function registerEdge(compKey) {
  var edgeName = 'flow-line';
  G6__default.registerEdge(edgeName, {
    draw: function draw(a, b) {
      var _G6$Arrow;

      var paramBase = getOrgRoot(compKey);
      var config = paramBase.config;
      var cfg = a;
      var group = b;
      var startPoint = cfg.startPoint;
      var endPoint = cfg.endPoint;
      var _config$card$vGap = config.card.vGap,
          lineTop = _config$card$vGap[0],
          lineBottom = _config$card$vGap[1];
      var difference = lineBottom - lineTop;
      var preCenterPoint = (startPoint.y + endPoint.y) / 2;
      var curCenterPoint = preCenterPoint - difference;

      var _getCardWidthHeight2 = getCardWidthHeight([], compKey),
          nodeHeight = _getCardWidthHeight2[1];

      return group.addShape('path', {
        attrs: {
          stroke: config.edge.edgeBackground,
          endArrow: {
            path: (_G6$Arrow = G6__default.Arrow).triangle.apply(_G6$Arrow, config.edge.arrowSize),
            fill: config.edge.arrowBackground,
            d: -nodeHeight / 2
          },
          lineJoin: 'round',
          lineWidth: config.edge.width,
          path: [['M', startPoint.x, startPoint.y], ['L', startPoint.x, curCenterPoint], ['L', endPoint.x, curCenterPoint], ['L', endPoint.x, endPoint.y]]
        }
      });
    },
    update: undefined
  });
  return edgeName;
};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = GeneratorFunctionPrototype;
  define(Gp, "constructor", GeneratorFunctionPrototype);
  define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  });
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  define(Gp, iteratorSymbol, function() {
    return this;
  });

  define(Gp, "toString", function() {
    return "[object Generator]";
  });

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, in modern engines
  // we can explicitly access globalThis. In older engines we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}
});

var listening = function listening(graph, container, props, compKey) {
  handleAssistBoxForHover(graph, compKey);
  handleAssistBoxForClick(graph, props);
  handleExpand(graph, props, compKey);

  if (typeof window !== 'undefined') {
    window.onresize = function () {
      if (!graph || graph.get('destroyed')) return;

      if (!container || !container.scrollWidth || !container.scrollHeight) {
        return;
      }

      graph.changeSize(container.scrollWidth, container.scrollHeight);
    };
  }
};

var handleAssistBoxForHover = function handleAssistBoxForHover(graph, compKey) {
  graph.on('node:mouseenter', function (evt) {
    var _getOrgRoot = getOrgRoot(compKey),
        config = _getOrgRoot.config;

    if (!config.assistBox.isShow) return;
    var item = evt.item;
    if (!item) return;
    var tmp = item.getContainer().findById(NODE_WHOLE.ID.GROUP);
    if (tmp && tmp.contain(evt.target)) return;
    item.getContainer().findById(ASSIST_BOX.ID.GROUP).show();
  });
  graph.on('node:mouseleave', function (evt) {
    var _getOrgRoot2 = getOrgRoot(compKey),
        config = _getOrgRoot2.config;

    if (!config.assistBox.isShow) return;
    var item = evt.item;
    if (!item) return;
    item.getContainer().findById(ASSIST_BOX.ID.GROUP).hide();
  });
};

var handleAssistBoxForClick = function handleAssistBoxForClick(graph, props) {
  graph.on(ASSIST_BOX.NAME.GROUP + ':click', function (evt) {
    var target = evt.target,
        item = evt.item;
    if (!item) return;

    var _target$get$split = target.get('name').split('_'),
        index = _target$get$split[2];

    var model = item.getModel();
    props.onAssistChange && props.onAssistChange(+index, model.meta, model);
  });
};

var handleExpand = function handleExpand(graph, props, compKey) {
  graph.on(NODE_WHOLE.NAME.COLLAPSE + ':click', /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(evt) {
      var item, model, _getOrgRoot3, config, depth, res, ss;

      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              item = evt.item;

              if (item) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              model = item.getModel();
              _getOrgRoot3 = getOrgRoot(compKey), config = _getOrgRoot3.config;
              depth = model.depth || 0;

              if (!(depth >= config.defaultDepth && !(model.children || []).length)) {
                _context.next = 17;
                break;
              }

              setExpandLoading(item.getContainer(), true);
              _context.next = 10;
              return props.onExpand(model.meta, model);

            case 10:
              res = _context.sent;
              setExpandLoading(item.getContainer(), false);
              ss = traverseTree({
                children: res
              }, compKey, depth);
              model.collapsed = false;
              graph.updateChildren(ss.children, model.id);
              _context.next = 20;
              break;

            case 17:
              model.collapsed = !model.collapsed;
              graph.layout();
              graph.setItemState(item, 'collapse', model.collapsed);

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }());
};

var setExpandLoading = function setExpandLoading(group, status) {
  group.findAll(function (v) {
    if (v.get('name') === NODE_WHOLE.NAME.COLLAPSE) {
      status ? v.hide() : v.show();
    }

    if (v.get('name') === NODE_WHOLE.NAME.LOADINGBk) {
      !status ? v.hide() : v.show();
    }

    if (v.get('name') === NODE_WHOLE.NAME.LOADING) {
      if (!status) {
        v.hide();
        v.stopAnimate();
        return false;
      }

      v.show();
      var x = v.attr('x');
      var y = v.attr('y');
      v.animate(function (ratio) {
        var toMatrix = G6__default.Util.transform([1, 0, 0, 0, 1, 0, 0, 0, 1], // 初始矩阵，不用管
        [['t', -x, -y], ['r', ratio * Math.PI * 2], ['t', x, y]]);
        return {
          matrix: toMatrix
        };
      }, {
        repeat: true,
        duration: 1000
      });
    }

    return false;
  });
}; // @ts-ignore;

var getMinimap = function getMinimap() {
  var minimap = new G6__default.Minimap({
    size: [150, 100],
    type: 'delegate'
  });
  return minimap;
};
var getTooltipEllipsis = function getTooltipEllipsis(compKey) {
  var param = getOrgRoot(compKey);
  var cardMap = param.cardMap;
  var _CONTENT$NAME$PREFIX = CONTENT.NAME.PREFIX,
      MAIN_TEXT = _CONTENT$NAME$PREFIX.MAIN_TEXT,
      SUB_TEXT = _CONTENT$NAME$PREFIX.SUB_TEXT,
      EXTRA_TEXT = _CONTENT$NAME$PREFIX.EXTRA_TEXT;

  var fn = function fn(e) {
    var item = e.item,
        target = e.target;
    var n = target.get('name') || '';
    var source = item.getModel();
    var _cardMap$managerEmp = cardMap.managerEmp,
        key = _cardMap$managerEmp.key,
        value = _cardMap$managerEmp.value;

    var isShow = function isShow(valueKey) {
      var _n$split = n.split('_'),
          index = _n$split[2];

      if (source.meta[key][index][valueKey] === undefined) {
        return {
          show: false,
          value: ''
        };
      }

      if (target.attr('text') === source.meta[key][index][valueKey]) {
        return {
          show: false,
          value: ''
        };
      }

      return {
        show: true,
        value: source.meta[key][index][valueKey]
      };
    };

    if (n.includes(MAIN_TEXT)) {
      return isShow(value.name);
    }

    if (n.includes(SUB_TEXT)) {
      return isShow(value.jobTitle);
    }

    if (n.includes(EXTRA_TEXT)) {
      return isShow(value.jobLevel);
    }

    return {
      show: false,
      value: ''
    };
  };

  var tooltip = new G6__default.Tooltip({
    offsetX: 10,
    offsetY: 20,
    getContent: function getContent(e) {
      var res = fn(e).value;
      var outDiv = document.createElement('div');
      outDiv.className = 'orgChartTextEllipsis';
      outDiv.innerHTML = "" + res;
      return outDiv;
    },
    shouldBegin: function shouldBegin(e) {
      return fn(e).show;
    },
    itemTypes: ['node']
  });
  return tooltip;
};

var Index = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var dataSource = props.dataSource || data;
  var cardMap = getCardMap(props.cardMap);
  var config = getConfig(props.config);
  var canvasRef = React.useRef(null);
  var compKey = React.useRef(Math.random() + 'sp');
  var showHide = React.useRef(defaultShow);
  var graphRef = React.useRef(null); // 基础入参，数据key，大小间距，显隐配置
  // const paramBase = { cardMap, config, showHide: showHide.current };

  React.useImperativeHandle(ref, function () {
    return {
      changeCanvasSize: changeCanvasSize,
      changeShowMode: changeShowMode,
      changeConfig: changeConfig,
      changeCardMap: changeCardMap
    };
  });

  var changeCardMap = function changeCardMap(param) {
    setOrgRoot(compKey.current, {
      cardMap: getCardMap(param)
    });
    graphRef.current.refresh();
    graphRef.current.layout();
  };

  var changeConfig = function changeConfig(param) {
    var isReload = false;
    var preData = getOrgRoot(compKey.current);

    if (param && param.defaultDepth !== undefined && preData.config.defaultDepth !== param.defaultDepth) {
      var maxDepth = getTreeDepth(dataSource);

      if (maxDepth < param.defaultDepth) {
        alert("\u6E90\u6570\u636E\u6700\u5927\u5C42\u6570\uFF1A" + maxDepth + "\uFF0C\u4F46\u662FdefaultDepth\u8BBE\u7F6E\u4E86\uFF1A" + param.defaultDepth);
        console.error('defaultDepth太大了，默认数据最大层数只有：' + getTreeDepth(dataSource));
        return;
      } // 更改默认展开层数，需要重新更改数据源，重新定位


      isReload = true;
    }

    setOrgRoot(compKey.current, {
      config: getConfig(param)
    });

    if (isReload) {
      var res = traverseTree(dataSource, compKey.current, 0);
      graphRef.current.changeData(res);
      graphRef.current.translate(props.width / 2, props.height / 2 - 100);
    }

    graphRef.current.refresh();
    graphRef.current.layout();
  };

  var changeShowMode = function changeShowMode(param) {
    setOrgRoot(compKey.current, {
      showHide: getDefaultShow(param)
    });
    graphRef.current.refresh();
    graphRef.current.layout();
  };
  /**
   * TODO: 通过render的方法，在大数据场景下应该会很慢
   * 修改画布尺寸
   * @param width 宽度
   * @param height 高度
   */


  var changeCanvasSize = function changeCanvasSize(width, height) {
    graphRef.current.changeSize(width, height);
    graphRef.current.render();
    graphRef.current.translate(width / 2, height / 2);
  };

  var renderPic = function renderPic() {
    var data = traverseTree(dataSource, compKey.current, 0);
    var defaultLayout = getDefaultLayout(compKey.current);
    var eventName = initScroll(compKey.current);
    var nodeName = registerNode(compKey.current);
    var edgeName = registerEdge(compKey.current);
    var container = canvasRef.current;
    var width = props.width || container.scrollWidth;
    var height = props.height || 500;
    var graph = new G6__default.TreeGraph({
      container: container,
      width: width,
      height: height,
      linkCenter: true,
      plugins: [getMinimap(), getTooltipEllipsis(compKey.current)],
      modes: {
        "default": [eventName, {
          type: 'drag-canvas'
        }, {
          type: 'zoom-canvas',
          enableOptimize: true,
          shouldUpdate: function shouldUpdate(evt) {
            return !(Math.abs(evt.deltaY) <= 2 || Math.abs(evt.deltaX) - Math.abs(evt.deltaY) > 10);
          }
        }]
      },
      defaultNode: {
        type: nodeName
      },
      defaultEdge: {
        type: edgeName
      },
      layout: defaultLayout
    });
    graph.set('animate', false);
    graph.data(data);
    graph.render();
    graph.translate(width / 2, height / 2 - 100);
    graphRef.current = graph;
    listening(graph, container, props, compKey.current);
  };

  React.useEffect(function () {
    setOrgRootFirst(compKey.current, {
      cardMap: cardMap,
      config: config,
      showHide: showHide.current
    });
    renderPic();
  }, []);
  return React__default.createElement("div", {
    className: "orgChartBox"
  }, React__default.createElement("div", {
    ref: canvasRef
  }));
});

exports.config = config;
exports.default = Index;
exports.defaultMap = defaultMap;
//# sourceMappingURL=rlj-org-chart.cjs.development.js.map
